unit main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ValEdit,
  StdCtrls,LazUtf8, Grids,contnrs, LCLProc, Buttons;

type
   THackValueListEditor = class(TValueListEditor)
   end;

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button10: TButton;
    Button11: TButton;
    Button12: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    CBEd: TCheckBox;
    AssertCB: TCheckBox;
    KeyDeleteCB: TCheckBox;
    KeyUniqueCB: TCheckBox;
    KeyAddCB: TCheckBox;
    KeyEditCB: TCheckBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Memo1: TMemo;
    Memo2: TMemo;
    Memo3: TMemo;
    TestSpeedBtn: TSpeedButton;
    ValEd: TValueListEditor;
    Clone: TValueListEditor;
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button12Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure CBEdChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure KeyAddCBChange(Sender: TObject);
    procedure KeyDeleteCBChange(Sender: TObject);
    procedure KeyEditCBChange(Sender: TObject);
    procedure KeyUniqueCBChange(Sender: TObject);
    procedure OSE(Sender: TObject; aCol, aRow: Integer;
      var Editor: TWinControl);
    procedure GPL(Sender: TObject; const KeyName: string;
      Values: TStrings);
    procedure TestSpeedBtnClick(Sender: TObject);
    procedure ValEdPrepareCanvas(sender: TObject; aCol, aRow: Integer;
      aState: TGridDrawState);
  private
    { private declarations }
    FKeyUpdating: Boolean;
    procedure SC(Sender: TObject);
    procedure SCC(Sender: TObject);
    procedure ED(Sender: TObject);
    procedure EBC(Sender: TObject);
    procedure BC(Sender: TObject; aCol, aRow: Integer);
    procedure VE(sender: TObject; aCol, aRow: Integer;
              const OldValue: string; var NewValue: String);
  public
    { public declarations }
  end;



  { TProps }






var
  Form1: TForm1;


implementation



{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
const
  Count: Integer = 0;
begin
  //ValEd.Strings.Clear;
  writeln('================================');
  Inc(Count);
  ValEd.Strings.Insert(0,'InsertBtn ('+inttostr(count)+')=InsertItem');
  ValEd.Col := 0;
  writeln('================================');
end;

procedure TForm1.Button10Click(Sender: TObject);
begin
  Clone.Strings.Clear;
  Clone.Strings.Assign(ValEd.Strings);
end;

procedure TForm1.Button11Click(Sender: TObject);
var
  Index: Integer;
  Key,Value,Line: String;
  Res: Boolean;
  aRow: Integer;
begin
  ValEd.Columns.Add;
  EXIT;

  //ValEd.Clear;
  Valed.InsertRow('aKey','aValue',True);
end;

procedure TForm1.Button12Click(Sender: TObject);
var
  Res: Integer;
begin
  writeln('================================');
  ValEd.InsertRowWithValues(0,['Hallo','World']);
  //ValEd.Strings.Insert(0,'Hallo=World');
  //writeln('InsertRow=',Res);
  //self.ActiveControl := ValEd;
  writeln('================================');

{
================================
TValueListStrings.InsertItem: Index=0 S=Hallo=World AObject=00000000
CanHideShowingEditor:
 Assigned(FGrid.Editor) = FALSE
 (goAlwaysShowEditor in FGrid.Options) = TRUE
 FGrid.Editor.Visible = UnAssigned
 IndexToRow = 1
 Count = 0
 EditorHasFocus = FALSE
 Col = 0
 Row = 1
CanHideShowingEditor: Result = FALSE
================================
}

end;

procedure TForm1.Button2Click(Sender: TObject);
const
  Count: Integer = 0;
begin
  //ValEd.Strings.Clear;
  Inc(Count);
  if ValEd.Strings.Count > 0 then
  begin
    writeln('--------------------');
    ValEd.Strings.Strings[0] := 'PuBtn ('+inttostr(count)+')=Put';
    writeln('--------------------');
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  //if ValEd.Strings.Count > 0 then ValEd.Strings.Delete(0);
  ValEd.DeleteRow(1);
end;

procedure TForm1.Button4Click(Sender: TObject);
var
  W: Integer;
  i: Integer;
  s: String;
begin
  //Memo1.Lines.Assign(ValEd.Strings); ///
  ValEd.Strings.Assign(memo1.lines);
  Clone.Strings.Assign(memo1.lines);
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  ValEd.Strings.Text := 'Text1=1'+LineEnding+'Text2=2';
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  ValEd.Strings.Clear;
  Valed.Strings.Add('MyYesNoRO=No');

  with ValEd.ItemProps['MyYesNoRO'] do
  begin
    KeyDesc := 'MyYesNo: PickList';
    EditStyle := esPickList;
    ReadOnly := True;
    PickList.Add('Yes');
    PickList.Add('No');
  end;

  ValEd.Strings.Add('MyPlainRW=Vanilla');
  with ValEd.ItemProps['MyPlainRW'] do
  begin
    ReadOnly := false;
  end;

  ValEd.Strings.Add('MyPlainRO=ReadOnly');
  with ValEd.ItemProps['MyPlainRO'] do
  begin
    ReadOnly := true;
  end;

  Valed.Strings.Add('MyBoolRW=False');
  with ValEd.ItemProps['MyBoolRW'] do
  begin
    KeyDesc := 'MyBool: PickList';
    EditStyle := esPickList;
    ReadOnly := false;
    PickList.Add('False');
    PickList.Add('True');
  end;

  Valed.Strings.Add('MyLongRO=1');
  with ValEd.ItemProps['MyLongRO'] do
  begin
    KeyDesc := 'MyLong: PickList';
    EditStyle := esPickList;
    ReadOnly := True;
    PickList.Add('1');
    PickList.Add('2');
    PickList.Add('3');
    PickList.Add('4');
    PickList.Add('5');
    PickList.Add('6');
    PickList.Add('7');
    PickList.Add('8');
    PickList.Add('9');
    PickList.Add('10');
  end;

  ValEd.Strings.Add('FontRW=Arial');
  with ValEd.ItemProps['FontRW'] do
  begin
    KeyDesc := 'Font: Ellipsis';
    EditStyle := esEllipsis;
  end;

  ValEd.Strings.Add('FontRO=Coutier New');
  with ValEd.ItemProps['FontRO'] do
  begin
    ReadOnly := True;
    KeyDesc := 'Font: Ellipsis';
    EditStyle := esEllipsis;
  end;

  ValEd.DropDownRows := 4;

end;

procedure TForm1.Button7Click(Sender: TObject);
begin
  ValEd{.Strings}.Clear;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  if ValEd.Strings.Count > 1 then
  begin
    writeln('-------------Exchange---------------');
    ValEd.Strings.Exchange(0,1);
    writeln('-------------Exchange---------------');
  end;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  ValEd.Strings.Sort;
end;

procedure TForm1.CBEdChange(Sender: TObject);
begin
  if CBEd.Checked then
  begin
    ValEd.Options := ValEd.Options + [goAlwaysShowEditor];
    Clone.Options := Clone.Options + [goAlwaysShowEditor];
  end
  else
  begin
    ValEd.Options := ValEd.Options - [goAlwaysShowEditor];
    Clone.Options := Clone.Options - [goAlwaysShowEditor];
  end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  ValEd.Col := 0;
  ValEd.Repaint;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  FKeyUpdating := False;         //valed.rowcount
  ValEd.OnStringsChange := @SC;
  //Clone.OnStringsChange := @SC;
  //ValEd.OnStringsChanging := @SCC;
  //ValEd.OnEditingDone := @ED;
  //ValEd.OnValidateEntry := @VE;
  //valed.strings.Strings[0] := '@@';
  //ValEd.BeginUpdate;
  //(ValEd).OnEditButtonClick := @EBC;
  (ValEd).OnButtonClick := @BC;
  //ValEd.OnGetPickList := @GPL;


  ValEd.Strings.Clear;

  //ValEd.OnSelectEditor := @OSE;
  //Clone.OnSelectEditor := @OSE;
  SC(Self);
  CBEdChange(Self);
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  FKeyUpdating := True;
  KeyAddCB.Checked := KeyAdd in ValEd.KeyOptions;
  KeyDeleteCB.Checked := KeyDelete in ValEd.KeyOptions;
  KeyEditCB.Checked := KeyEdit in ValEd.KeyOptions;
  KeyUniqueCB.Checked := KeyUnique in ValEd.KeyOptions;
  CBed.Checked := goAlwaysShowEditor in ValEd.Options;
  FKeyUpdating := False;
end;

procedure TForm1.KeyAddCBChange(Sender: TObject);
begin
  if FKeyUpdating then Exit;
  FKeyUpdating :=  True;
  if KeyAddCB.Checked then
    ValEd.KeyOptions := ValEd.KeyOptions + [KeyAdd]
  else
    ValEd.KeyOptions := ValEd.KeyOptions - [KeyAdd];
  KeyAddCB.Checked := KeyAdd in ValEd.KeyOptions;
  FKeyUpdating := False;
end;

procedure TForm1.KeyDeleteCBChange(Sender: TObject);
begin
  if FKeyUpdating then Exit;
  FKeyUpdating :=  True;
  if KeydeleteCB.Checked then
    ValEd.KeyOptions := ValEd.KeyOptions + [KeyDelete]
  else
    ValEd.KeyOptions := ValEd.KeyOptions - [KeyDelete];
  KeyDeleteCB.Checked := KeyDelete in ValEd.KeyOptions;
  FKeyUpdating := False;
end;

procedure TForm1.KeyEditCBChange(Sender: TObject);
begin
  if FKeyUpdating then Exit;
  FKeyUpdating :=  True;
  if KeyEditCB.Checked then
    ValEd.KeyOptions := ValEd.KeyOptions + [KeyEdit]
  else
    ValEd.KeyOptions := ValEd.KeyOptions - [KeyEdit];
  KeyEditCB.Checked := KeyEdit in ValEd.KeyOptions;
  KeyDeleteCB.Checked := KeyDelete in ValEd.KeyOptions;
  KeyAddCB.Checked := KeyAdd in ValEd.KeyOptions;
  FKeyUpdating := False;
  writeln('KeyEditCBChange: (KeyEdit in ValEd.KeyOptions) = ',KeyEdit in ValEd.KeyOptions);
end;

procedure TForm1.KeyUniqueCBChange(Sender: TObject);
begin
  if KeyUniqueCB.Checked then
    ValEd.KeyOptions := ValEd.KeyOptions + [KeyUnique]
  else
    ValEd.KeyOptions := ValEd.KeyOptions - [KeyUnique];
end;

procedure TForm1.OSE(Sender: TObject; aCol, aRow: Integer;
  var Editor: TWinControl);
var
  PLE: TPickListCelleditor;
  IP: TItemProp;
begin
  write('[',TComponent(Sender).Name,'] OnSelectEditor: Col=',acol,' Row=',arow);
  if AssertCB.Checked and (Sender=ValEd) then writeln(' ???????')
  else writeln;
end;

procedure TForm1.GPL(Sender: TObject; const KeyName: string;
  Values: TStrings);
begin
  writeln('[',(Sender as TComponent).Name,'].OnGetPickList: KeyName=',KeyName);
end;

procedure TForm1.TestSpeedBtnClick(Sender: TObject);
begin
  writeln('(KeyEdit in ValEd.KeyOptions) = ',(KeyEdit in ValEd.KeyOptions));
end;

procedure TForm1.ValEdPrepareCanvas(sender: TObject; aCol, aRow: Integer;
  aState: TGridDrawState);
begin
  if (aCol = 0) and not (gdFixed in aState) then
  begin
    ValEd.Canvas.Brush.Color := clYellow;
  end;
end;

procedure TForm1.SC(Sender: TObject);
begin
  //writeln('StringsChange: ',Tcomponent(Sender).Name);
  if (sender = ValEd) then Memo2.Lines.Assign(ValEd.Strings);
  if (sender = Clone) then Memo3.Lines.Assign(Clone.Strings);
end;

procedure TForm1.SCC(Sender: TObject);
begin
  writeln('StringsChanging: ',TComponent(Sender).Name);
end;

procedure TForm1.ED(Sender: TObject);
begin
  //writeln('EditingDone');
end;

procedure TForm1.EBC(Sender: TObject);
begin
  writeln('OnEditButtonClick');
end;

procedure TForm1.BC(Sender: TObject; aCol, aRow: Integer);
var
  IProp: TItemProp;
  Desc: String;
begin
  if (ACol = 1) then
  begin
    try
      IProp := ValEd.ItemProps[ARow - ValEd.FixedRows];
    except
      IProp := nil;
      Desc := 'nil';
    end;
    if Assigned(IProp) then
    begin
      Desc := Iprop.KeyDesc;

    end;
    writeln('ButtonClick: ARow=',Arow,' ACol=',Acol,' ItemProp.KeyDescr=',Desc);

  end;
end;

procedure TForm1.VE(sender: TObject; aCol, aRow: Integer;
  const OldValue: string; var NewValue: String);
var
  i, P: Integer;
  Index: Integer;
  S: String;
begin
  exit;


  writeln('ValidateEntry: ACol = ',ACol,' ARow = ',ARow,' OldValue = ',OldValue,' NewValue = ',NewValue);
  P := Valed.Strings.IndexOfName(NewValue);
  {if (P > 0) then }
  Index := ARow - ValEd.FixedRows;
  writeln('--P = ',P,' Index = ',Index);

  for i := 0 to ValEd.Strings.Count - 1 do
  begin
    if (Index <> i) then
    begin
      S := ValEd.Strings.Names[i];
      if Utf8CompareText(S, NewValue) = 0 then
      begin
        writeln('Found duplicate key at i = ',i,' [Row = ',i + ValEd.FixedRows,']');
      end;

    end;
  end;
end;

{
Modified?

}
end.

